% Base de donnees relationnelle
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% | ?- pere(julien,simon).
% | ?- pere(X,Y).
% | ?- gdpere(X,Y).

:- dynamic(mere/2,pere/2,parent/2,gdpere/2,gdmere/2).
:- initialization(gui_trace_call_predicate(mere/2)).
:- initialization(gui_trace_call_predicate(pere/2)).
:- initialization(gui_trace_call_predicate(parent/2)).
:- initialization(gui_trace_call_predicate(gdpere/2)).
:- initialization(gui_trace_call_predicate(gdmere/2)).


pere(alphonse, chantal).
pere(julien,simon).
mere(emilie,chantal).
mere(chantal,julien).

parent(X,Y):-pere(X,Y).
parent(X,Y):-mere(X,Y).

gdpere(X,Y):-pere(X,Z),parent(Z,Y).
gdmere(X,Y):-mere(X,Z),parent(Z,Y).

% lists
%%%%%%%
:- dynamic(app/3).
:- initialization(gui_trace_call_predicate(app/3)).

app([],B,B).
app([X|A],B,[X|C]):- app(A,B,C).

:- dynamic(mem/2).
:- initialization(gui_trace_call_predicate(mem/2)).

mem(X,[X|_]).
mem(X,[_|L]):- mem(X,L).

:- dynamic(revers/2,rev/2,rev_lin/3).
:- initialization(gui_trace_call_predicate(revers/2)).
:- initialization(gui_trace_call_predicate(rev/2)).
:- initialization(gui_trace_call_predicate(rev_lin/3)).

revers([],[]).
revers([X|L],R):-revers(L,K),app(K,[X],R).

rev(L,R):-rev_lin(L,[],R).

rev_lin([],R,R).
rev_lin([X|L],K,R):-rev_lin(L,[X|K],R).

% Quicksort
%%%%%%%%%%%
:- dynamic(tri_rapide/2,partition/4).
:- initialization(gui_trace_call_predicate(tri_rapide/2)).
:- initialization(gui_trace_call_predicate(partition/4)).

tri_rapide([],[]).
tri_rapide([X|L],R):-
    partition(L,Linf,X,Lsup),
    tri_rapide(Linf,L1),
    tri_rapide(Lsup,L2),
    app(L1,[X|L2],R).

partition([],[],_,[]).
partition([Y|L],[Y|Linf],X,Lsup):-
    Y=<X,
    partition(L,Linf,X,Lsup).
partition([Y|L],Linf,X,[Y|Lsup]):-
    Y>X,
    partition(L,Linf,X,Lsup).

% Grammaire
%%%%%%%%%%%
:- dynamic(sentence/1,nounphrase/1,verbphrase/1,determiner/1,noun/1,verb/1).
:- initialization(gui_trace_call_predicate(sentence/1)).
:- initialization(gui_trace_call_predicate(nounphrase/1)).
:- initialization(gui_trace_call_predicate(verbphrase/1)).
:- initialization(gui_trace_call_predicate(determiner/1)).
:- initialization(gui_trace_call_predicate(noun/1)).
:- initialization(gui_trace_call_predicate(verb/1)).

sentence(L):-nounphrase(L1), verbphrase(L2), append(L1,L2,L).
nounphrase(L):- determiner(L1), noun(L2), append(L1,L2,L).
nounphrase(L):- noun(L).
verbphrase(L):- verb(L).
verbphrase(L):- verb(L1), nounphrase(L2), append(L1,L2,L).
verb([eats]).
determiner([the]).
noun([monkey]).
noun([banana]).



